/* LittleDarwin generated mutant
 mutant type: conditionalOperatorReplacement
 ----> before: inStartingState   ( )  ^ inPlayingState   ( )   ^ inHaltedState   ( )   ^ inDiedState   ( )   ^ inWonState   ( )   && ! ( inStartingState   ( )  && inPlayingState   ( )   && inHaltedState   ( )   && inDiedState   ( )   && inWonState   ( )   )    
----> after: inStartingState   ( )  ^ inPlayingState   ( )   ^ inHaltedState   ( )   ^ inDiedState   ( )   ^ inWonState   ( )   || ! ( inStartingState   ( )  && inPlayingState   ( )   && inHaltedState   ( )   && inDiedState   ( )   && inWonState   ( )   )    
----> line number in original file: 92
----> mutated nodes: 1090
*/ 

package jpacman . model  ;
 import java . util . Observable  ;
 import java . util . Vector  ;
 public  class Engine extends Observable   { private   Game   theGame    ;
   private   boolean   starting  = false       ;
   private   boolean   halted  = false       ;
   public   synchronized  boolean   inStartingState ( )  { return starting   && ! ( theGame   . playerDied  ( )  || theGame   . playerWon  ( )   )     ;
  }      public   synchronized  boolean   inPlayingState ( )  { return ! starting    && ! halted     && theGame   . initialized  ( )   && ! theGame   . playerDied  ( )    && ! theGame   . playerWon  ( )    ;
  }      public   synchronized  boolean   inDiedState ( )  { return ! starting    && theGame   . playerDied  ( )   ;
  }      public   synchronized  boolean   inWonState ( )  { return ! starting    && theGame   . playerWon  ( )   ;
  }      public   synchronized  boolean   inHaltedState ( )  { return halted   ;
  }      public   synchronized  boolean   inGameOverState ( )  { return inDiedState   ( )  || inWonState   ( )   ;
  }      protected   boolean   invariant ( )  { boolean   oneStateOnly  = inStartingState   ( )  ^ inPlayingState   ( )   ^ inHaltedState   ( )   ^ inDiedState   ( )   ^ inWonState   ( )   || ! ( inStartingState   ( )  && inPlayingState   ( )   && inHaltedState   ( )   && inDiedState   ( )   && inWonState   ( )   )         ;
  return oneStateOnly   && theGame   != null      ;
  }      public   Engine ( )  { theGame   = new Game  ( )       ;
  initialize   ( theGame    )   ;
  assert inStartingState   ( )  ;
  assert invariant   ( )  ;
  }      public   Engine ( Game   g    )  { assert g   != null     ;
  assert g   . initialized  ( )  ;
  initialize   ( g    )   ;
  }      private   void initialize ( Game   g    )  { assert g   != null     ;
  assert g   . initialized  ( )  ;
  theGame   = g     ;
  starting   = true      ;
  assert inStartingState   ( )  ;
  assert invariant   ( )  ;
  }      public   synchronized  void quit ( )  { assert invariant   ( )  ;
  if ( inPlayingState   ( )  )  { halted   = true      ;
  notifyViewers   ( )   ;
  }     assert invariant   ( )  ;
  }      public   synchronized  void start ( )  { assert invariant   ( )  ;
  if ( inHaltedState   ( )  )  { assert halted   ;
  halted   = false      ;
  }   else { if ( inStartingState   ( )  )  { assert starting   ;
  starting   = false      ;
  }   else { if ( inGameOverState   ( )  )  { assert ! starting    ;
  theGame   . initialize  ( )   ;
  starting   = true      ;
  }     }     }     notifyViewers   ( )   ;
  assert invariant   ( )  : "Invariant invalid after updating the viewers"    ;
  }      public   synchronized  void movePlayer ( int   dx   , int   dy    )  { assert invariant   ( )  ;
  if ( inPlayingState   ( )  )  { theGame   . movePlayer  ( dx   , dy    )   ;
  notifyViewers   ( )   ;
  }     assert invariant   ( )  ;
  }      public   synchronized  void moveMonster ( Monster   monster   , int   dx   , int   dy    )  { }      private   void notifyViewers ( )  { setChanged   ( )   ;
  notifyObservers   ( )   ;
  }      Game   getGame ( )  { return theGame   ;
  }      public   synchronized  char   getGuestCode ( int   x   , int   y    )  { return getGame   ( )  . getGuestCode  ( x   , y    )  ;
  }      public   synchronized  int   boardWidth ( )  { return getGame   ( )  . boardWidth  ( )  ;
  }      public   synchronized  int   boardHeight ( )  { assert invariant   ( )  ;
  return getGame   ( )  . boardHeight  ( )  ;
  }      public   synchronized  int   getFoodEaten ( )  { assert invariant   ( )  ;
  return getPlayer   ( )  . getPointsEaten  ( )  ;
  }      public   synchronized  Vector <Monster    >   getMonsters ( )  { assert invariant   ( )  ;
  Vector <Monster    >   result  = theGame   . getMonsters  ( )      ;
  assert result   != null     ;
  return result   ;
  }      public   synchronized  Player   getPlayer ( )  { assert invariant   ( )  ;
  return theGame   . getPlayer  ( )  ;
  }      public   synchronized  int   getPlayerLastDx ( )  { return getGame   ( )  . getPlayerLastDx  ( )  ;
  }      public   synchronized  int   getPlayerLastDy ( )  { return getGame   ( )  . getPlayerLastDy  ( )  ;
  }      }      